Index: main/waeup.kofa/trunk/src/waeup/kofa/accesscodes/accesscode.txt
===================================================================
--- main/waeup.kofa/trunk/src/waeup/kofa/accesscodes/accesscode.txt	(revision 12919)
+++ main/waeup.kofa/trunk/src/waeup/kofa/accesscodes/accesscode.txt	(revision 12920)
@@ -1,4 +1,4 @@
-:mod:`waeup.kofa.accesscodes.accesscode` -- access codes (aka PINs)
-*******************************************************************
+Access Codes (aka PINs)
+***********************
 
 .. module:: waeup.kofa.accesscodes.accesscode
@@ -9,5 +9,5 @@
 .. :NOlayer: waeup.kofa.testing.KofaUnitTestLayer
 
-About access-codes
+About Access Codes
 ==================
 
@@ -34,10 +34,10 @@
 
 
-AccessCode
-==========
+Access Code
+===========
 
 .. class:: AccessCode(batch_serial, random_num[,invalidation_date=None[, student_id=None]])
 
-   You normally shouldn't create standalone access-codes. Use
+   You normally shouldn't create standalone access codes. Use
    instances of :class:`AccessCodeBatch` instead as they generate them
    (in masses) and care for them.
@@ -47,10 +47,10 @@
    :class:`AccessCodeBatch`) to be kept.
 
-   Access-codes can have three states: unused, used, and
-   disabled. While still unused but enabled access-codes are reflected
+   Access codes can have three states: unused, used, and
+   disabled. While still unused but enabled access codes are reflected
    by an empty ``invalidation_date`` (set to ``None``), an already
    used (invalidated) code provides an invalidation date.
 
-   In case of misuse or similar cases access-codes can also be
+   In case of misuse or similar cases access codes can also be
    completely disabled by setting the ``disabled`` attribute to
    ``True``.
@@ -133,10 +133,10 @@
 
 
-AccessCodeBatch
-===============
+Access Code Batch
+=================
 
 .. class:: AccessCodeBatch(creation_date, creator, batch_prefix, cost, entry_num, num)
 
-   Create a batch of access-codes.
+   Create a batch of access codes.
 
    :param creation_date: python datetime
@@ -152,5 +152,5 @@
    :class:`waeup.kofa.accesscodes.interfaces.IAccessCodeBatch`.
 
-   When creating a batch, all entries (access-codes) are generated as
+   When creating a batch, all entries (access codes) are generated as
    well.
 
@@ -170,5 +170,5 @@
    .. attribute:: entry_num
 
-      Number of entries (access-codes) inside the batch.
+      Number of entries (access codes) inside the batch.
 
    .. attribute:: invalidated_num
@@ -298,5 +298,5 @@
       Lookup is done via local BTrees and therefore pretty fast.
 
-      Returns a list of access-codes found or empty list.
+      Returns a list of access codes found or empty list.
 
 
@@ -312,5 +312,5 @@
     True
 
-Creating a batch of three access-codes, with a cost of ``12.12`` per
+Creating a batch of three access codes, with a cost of ``12.12`` per
 code, the batch prefix ``APP``, batch number ``10``, creator ID
 ``Fred`` and some arbitrary creation date:
@@ -321,5 +321,5 @@
     ...   datetime.datetime(2009, 12, 23), 'Fred','APP', 12.12, 3, num=10)
 
-Getting all access-codes from a batch:
+Getting all access codes from a batch:
 
     >>> ac_codes = batch.entries()
@@ -472,6 +472,6 @@
 #    []
 
-AccessCodeBatchContainer
-========================
+Access Code Batch Container
+===========================
 
 .. class:: AccessCodeBatchContainer()
@@ -540,6 +540,6 @@
         be a string containing the full student ID.
 
-Examples:
----------
+Examples
+--------
 
 Creating a batch container:
@@ -586,5 +586,5 @@
 
 
-Access code plugin
+Access Code Plugin
 ==================
 
@@ -592,5 +592,5 @@
 
   A `waeup.kofa` plugin that updates existing Kofa university
-  instances so that they provide support for access-codes.
+  instances so that they provide support for access codes.
 
   .. attribute:: grok.implements(IKofaPluggable)
Index: main/waeup.kofa/trunk/src/waeup/kofa/accesscodes/api.txt
===================================================================
--- main/waeup.kofa/trunk/src/waeup/kofa/accesscodes/api.txt	(revision 12919)
+++ 	(revision )
@@ -1,17 +1,0 @@
-:mod:`waeup.kofa.accesscodes` -- Access Codes
-*********************************************
-
-.. module:: waeup.kofa.accesscodes
-
-Components that represent access codes and related components.
-
-Submodules
-==========
-
-The :mod:`waeup.kofa.accesscodes` module provides the following submodules:
-
-.. toctree::
-   :maxdepth: 1
-
-   browser.txt
-   accesscodes.txt
Index: main/waeup.kofa/trunk/src/waeup/kofa/accesscodes/browser.txt
===================================================================
--- main/waeup.kofa/trunk/src/waeup/kofa/accesscodes/browser.txt	(revision 12919)
+++ main/waeup.kofa/trunk/src/waeup/kofa/accesscodes/browser.txt	(revision 12920)
@@ -1,4 +1,4 @@
-:mod:`waeup.kofa.accesscodes.browser` -- UI components for access-codes
-***********************************************************************
+UI Components for Access Codes
+******************************
 
 .. module:: waeup.kofa.accesscodes.browser
@@ -45,5 +45,5 @@
 
 
-Access-code management screen
+Access Code Management Screen
 =============================
 
@@ -66,5 +66,5 @@
     ...
 
-Adding batches
+Adding Batches
 ==============
 
@@ -336,5 +336,5 @@
 
 Enabling and Disabling Found Access Codes
------------------------------------------
+=========================================
 
 If a search is successfull, we can enable or disable the found access
@@ -421,5 +421,4 @@
 
 
-
 Archive files
 -------------
Index: main/waeup.kofa/trunk/src/waeup/kofa/browser/batchprocessing.txt
===================================================================
--- main/waeup.kofa/trunk/src/waeup/kofa/browser/batchprocessing.txt	(revision 12919)
+++ main/waeup.kofa/trunk/src/waeup/kofa/browser/batchprocessing.txt	(revision 12920)
@@ -1,3 +1,3 @@
-Batch processing via browser
+Batch Processing via Browser
 ****************************
 
@@ -58,5 +58,5 @@
 
 
-Batch processing faculties
+Batch Processing Faculties
 ==========================
 
@@ -166,5 +166,5 @@
 
 
-Batch processing departments
+Batch Processing Departments
 ============================
 
@@ -231,5 +231,5 @@
     ...File:...departments_zope.mgr.csv...
 
-Batch processing courses
+Batch Processing Courses
 ========================
 
@@ -296,5 +296,5 @@
     ...File:...courses_zope.mgr.csv...
 
-Batch processing certificates
+Batch Processing Certificates
 =============================
 
@@ -362,5 +362,5 @@
     ...File:...certificates_zope.mgr.csv...
 
-Batch processing certificate courses
+Batch Processing Certificate Courses
 ====================================
 
@@ -427,5 +427,5 @@
     ...File:...mycertcourses_zope.mgr.csv...
 
-Batch processing users
+Batch Processing Users
 ======================
 
@@ -499,5 +499,5 @@
    ['waeup.PortalManager', 'waeup.AcademicsOfficer', 'waeup.ImportManager']
 
-Pending files
+Pending Files
 =============
 
@@ -587,5 +587,5 @@
 
 
-Fixing the pending file
+Fixing the Pending File
 -----------------------
 
Index: main/waeup.kofa/trunk/src/waeup/kofa/browser/browser.txt
===================================================================
--- main/waeup.kofa/trunk/src/waeup/kofa/browser/browser.txt	(revision 12919)
+++ main/waeup.kofa/trunk/src/waeup/kofa/browser/browser.txt	(revision 12920)
@@ -984,6 +984,6 @@
 
 
-CertificateCourses
-==================
+Certificate Courses
+===================
 
 Once we have a certificate, we can add also certificate courses. These
@@ -1030,6 +1030,6 @@
 
 
-Adding certificatecourses
--------------------------
+Adding certificate courses
+--------------------------
 
 Certcourses are stored in :class:`ICertificate` instances
@@ -1057,5 +1057,5 @@
   ['--', 'COURSE1 - Course 1', 'COURSE2 - Course 2']
 
-We select the first course and create our certificatecourse:
+We select the first course and create our certificate course:
 
   >>> ctrl.getControl('COURSE1').selected = True
@@ -1063,5 +1063,5 @@
   >>> browser.getControl('Add certificate course').click()
 
-Our certificatecourse will be linked on the parent certificate page:
+Our certificate course will be linked on the parent certificate page:
 
   >>> browser.open(cert_url)
@@ -1070,5 +1070,5 @@
   'http://localhost/my...sity/faculties/TF/TD/certificates/CERT1/COURSE1_100'
 
-We can't add the same certificatecourse twice:
+We can't add the same certificate course twice:
 
   >>> cert_url = dept_url + '/certificates/CERT1'
@@ -1082,5 +1082,5 @@
   True
 
-When we started to add a new certificatecourse, we can also cancel the
+When we started to add a new certificate course, we can also cancel the
 process before submitting. This will bring us back to the certificate
 page:
@@ -1092,6 +1092,6 @@
 
 
-Modifying certificatecourses
-----------------------------
+Modifying certificate courses
+-----------------------------
 
 We can change the settings for a certcourse by clicking on the
@@ -1137,6 +1137,6 @@
   ...
 
-Searching certificatecourses
-----------------------------
+Searching certificate courses
+-----------------------------
 
   >>> browser.open('http://localhost/myuniversity/faculties/search')
@@ -1153,6 +1153,6 @@
   True
 
-Deleting certificatecourses
----------------------------
+Deleting certificate courses
+----------------------------
 
 We can delete certcourses by browsing the containing certificate manage page:
Index: main/waeup.kofa/trunk/src/waeup/kofa/catalog.txt
===================================================================
--- main/waeup.kofa/trunk/src/waeup/kofa/catalog.txt	(revision 12919)
+++ main/waeup.kofa/trunk/src/waeup/kofa/catalog.txt	(revision 12920)
@@ -1,4 +1,4 @@
-:mod:`waeup.kofa.catalog` -- Cataloging support Kofa
-****************************************************
+Cataloging Support
+******************
 
 .. module:: waeup.kofa.catalog
@@ -10,11 +10,6 @@
 .. :layer: waeup.kofa.testing.KofaUnitTestLayer
 
-.. contents::
-
-Classes
-=======
-
-:class:`KofaQuery`
-------------------
+The KofaQuery Class
+===================
 
 .. class:: KofaQuery()
Index: main/waeup.kofa/trunk/src/waeup/kofa/datacenter.txt
===================================================================
--- main/waeup.kofa/trunk/src/waeup/kofa/datacenter.txt	(revision 12919)
+++ main/waeup.kofa/trunk/src/waeup/kofa/datacenter.txt	(revision 12920)
@@ -1,4 +1,4 @@
-Kofa Data Center
-****************
+Data Center
+***********
 
 The Kofa data center cares for managing CSV files and importing then.
@@ -42,5 +42,5 @@
 
 Managing the storage path
--------------------------
+=========================
 
 We can set another storage path:
Index: main/waeup.kofa/trunk/src/waeup/kofa/permissions.txt
===================================================================
--- main/waeup.kofa/trunk/src/waeup/kofa/permissions.txt	(revision 12919)
+++ main/waeup.kofa/trunk/src/waeup/kofa/permissions.txt	(revision 12920)
@@ -1,4 +1,4 @@
-Kofa permissions and roles
-**************************
+Permissions and Roles
+*********************
 
 Permissions and roles used in a Kofa portal.
Index: main/waeup.kofa/trunk/src/waeup/kofa/university/api.txt
===================================================================
--- main/waeup.kofa/trunk/src/waeup/kofa/university/api.txt	(revision 12919)
+++ 	(revision )
@@ -1,30 +1,0 @@
-:mod:`waeup.kofa.university` -- academic components
-***************************************************
-
-.. module:: waeup.kofa.university
-
-Components that represent academic 'core' stuff like faculties, 
-
-Submodules
-==========
-
-The :mod:`waeup.kofa.university` module provides the following submodules:
-
-.. toctree::
-   :maxdepth: 1
-
-   certificate.txt
-   certificatescontainer.txt
-   course.txt
-   coursescontainer.txt
-   department.txt
-   faculty.txt
-   facultiescontainer.txt
-
-Additional infos about the referrers of courses and how they are
-handled can be found in:
-
-.. toctree::
-   :maxdepth: 1
-
-   certcourses.txt
Index: main/waeup.kofa/trunk/src/waeup/kofa/university/certcourses.txt
===================================================================
--- main/waeup.kofa/trunk/src/waeup/kofa/university/certcourses.txt	(revision 12919)
+++ main/waeup.kofa/trunk/src/waeup/kofa/university/certcourses.txt	(revision 12920)
@@ -1,8 +1,86 @@
-Certificate Courses
-*******************
-
-Courses are referred to by certificate courses.
-
-We can be sure, that when removing courses or referrers of them,
+.. _removecertificatecourses:
+
+Persistence of Certificate Courses
+==================================
+
+If a certificate course requires a certain course and this is course
+is deleted, also the referring certificate course is deleted.
+
+We setup a data structure that reflects typical usage. It looks like
+this::
+
+    Department-Instance
+    |
+    +---> courses
+    |        |
+    |        +--------------------> Course-Instance
+    |                                        ^
+    +---> certificates                       |
+             |                               |
+             +-----> Certificate-Instance    |
+                        |                    |
+                        +------> Certificate-Course
+
+The Certifcate Course here refers to a Course instance.
+
+In Python we build such a structure like this (from top to bottom):
+
+    >>> from zope.component import createObject
+    >>> mydept = createObject('waeup.Department')
+
+In real world use this data will be stored in a ZODB. We setup our own
+litte ZODB backend (which is easy!):
+
+    >>> from ZODB import FileStorage, DB
+    >>> dbpath = 'tinyData.fs'
+    >>> class TinyZODB(object):
+    ...   def __init__(self, path=dbpath):
+    ...     self.storage = FileStorage.FileStorage(path)
+    ...     self.db = DB(self.storage)
+    ...     self.connection = self.db.open()
+    ...     self.dbroot = self.connection.root()
+    ...   def close(self):
+    ...     self.connection.close()
+    ...     self.db.close()
+    ...     self.storage.close()
+
+Now we can use this ZODB as backend database and store our data
+structure:
+
+    >>> import transaction
+    >>> db = TinyZODB()
+    >>> dbroot = db.dbroot
+    >>> dbroot['mydept'] = mydept
+    >>> mycourse = createObject('waeup.Course')
+    >>> mycourse.code = 'MYCOURSE'
+    >>> mydept.courses.addCourse(mycourse)
+    >>> mycert = createObject('waeup.Certificate')
+    >>> mycert.code = 'MYCERT'
+    >>> mydept.certificates.addCertificate(mycert)
+    >>> mycert.addCertCourse(mycourse)
+
+    >>> transaction.commit()
+
+The data is now stored in the ZODB. We can close the DB, reopen it
+later and the data will still be there:
+
+    >>> db.close()
+    >>> newdb = TinyZODB()
+    >>> newdbroot = newdb.dbroot
+    >>> list(newdbroot)
+    ['mydept']
+
+The certificate course we stored in the certificate is indeed a
+referrer of the course, not a copy of it:
+
+    >>> course = newdbroot['mydept'].courses['MYCOURSE']
+    >>> certcourse = newdbroot['mydept'].certificates['MYCERT']['MYCOURSE_100']
+    >>> certcourse.course is course
+    True
+
+So, we can be sure that modifications to the course are immediately
+reflected in the certcourse.
+
+We can also be sure, that when removing courses or referrers of them,
 other data will be handled in a way we expect. That is,
 
@@ -140,2 +218,4 @@
     >>> list(fac['DEPT2'].courses)
     []
+
+
Index: main/waeup.kofa/trunk/src/waeup/kofa/university/certificate.txt
===================================================================
--- main/waeup.kofa/trunk/src/waeup/kofa/university/certificate.txt	(revision 12919)
+++ main/waeup.kofa/trunk/src/waeup/kofa/university/certificate.txt	(revision 12920)
@@ -1,4 +1,4 @@
-:mod:`waeup.kofa.university.certificate` -- Certificates for Kofa
-******************************************************************
+Certificates and Certificate Courses
+************************************
 
 .. module:: waeup.kofa.university.certificate
@@ -234,6 +234,6 @@
     <waeup.kofa.university.certificate.Certificate object at 0x...>
 
-CertificateCourses
-------------------
+Certificate Courses
+-------------------
 
 :class:`CertificateCourse` instances comply with the
@@ -258,85 +258,2 @@
     <waeup.kofa.university.certificate.CertificateCourse object at 0x...>
 
-.. _removecertificatecourses:
-
-Persistence of certificate courses
-----------------------------------
-
-If a certificate course requires a certain course and this is course
-is deleted, also the referring certificate course is deleted.
-
-We setup a data structure that reflects typical usage. It looks like
-this::
-
-    Department-Instance
-    |
-    +---> courses
-    |        |
-    |        +--------------------> Course-Instance
-    |                                        ^
-    +---> certificates                       |
-             |                               |
-             +-----> Certificate-Instance    |
-                        |                    |
-                        +------> Certificate-Course
-
-The certifcate-Course here refers to a Course-Instance.
-
-In Python we build such a structure like this (from top to bottom):
-
-    >>> from zope.component import createObject
-    >>> mydept = createObject('waeup.Department')
-
-In real world use this data will be stored in a ZODB. We setup our own
-litte ZODB backend (which is easy!):
-
-    >>> from ZODB import FileStorage, DB
-    >>> dbpath = 'tinyData.fs'
-    >>> class TinyZODB(object):
-    ...   def __init__(self, path=dbpath):
-    ...     self.storage = FileStorage.FileStorage(path)
-    ...     self.db = DB(self.storage)
-    ...     self.connection = self.db.open()
-    ...     self.dbroot = self.connection.root()
-    ...   def close(self):
-    ...     self.connection.close()
-    ...     self.db.close()
-    ...     self.storage.close()
-
-Now we can use this ZODB as backend database and store our data
-structure:
-
-    >>> import transaction
-    >>> db = TinyZODB()
-    >>> dbroot = db.dbroot
-    >>> dbroot['mydept'] = mydept
-    >>> mycourse = createObject('waeup.Course')
-    >>> mycourse.code = 'MYCOURSE'
-    >>> mydept.courses.addCourse(mycourse)
-    >>> mycert = createObject('waeup.Certificate')
-    >>> mycert.code = 'MYCERT'
-    >>> mydept.certificates.addCertificate(mycert)
-    >>> mycert.addCertCourse(mycourse)
-
-    >>> transaction.commit()
-
-The data is now stored in the ZODB. We can close the DB, reopen it
-later and the data will still be there:
-
-    >>> db.close()
-    >>> newdb = TinyZODB()
-    >>> newdbroot = newdb.dbroot
-    >>> list(newdbroot)
-    ['mydept']
-
-The certificate course we stored in the certificate is indeed a
-referrer of the course, not a copy of it:
-
-    >>> course = newdbroot['mydept'].courses['MYCOURSE']
-    >>> certcourse = newdbroot['mydept'].certificates['MYCERT']['MYCOURSE_100']
-    >>> certcourse.course is course
-    True
-
-So, we can be sure that modifications to the course are immediately
-reflected in the certcourse.
-
Index: main/waeup.kofa/trunk/src/waeup/kofa/userscontainer.txt
===================================================================
--- main/waeup.kofa/trunk/src/waeup/kofa/userscontainer.txt	(revision 12919)
+++ main/waeup.kofa/trunk/src/waeup/kofa/userscontainer.txt	(revision 12920)
@@ -1,4 +1,4 @@
-User container for the Kofa
-***************************
+Users Container
+***************
 
 .. :doctest:
Index: main/waeup.kofa/trunk/src/waeup/kofa/utils/api.txt
===================================================================
--- main/waeup.kofa/trunk/src/waeup/kofa/utils/api.txt	(revision 12919)
+++ 	(revision )
@@ -1,19 +1,0 @@
-:mod:`waeup.kofa.utils` -- misc. helpers
-****************************************
-
-.. module:: waeup.kofa.utils
-
-Components and other stuff of general interest.
-
-Submodules
-==========
-
-The :mod:`waeup.kofa.utils` module provides the following submodules:
-
-.. toctree::
-   :maxdepth: 1
-
-   helpers.txt
-   batching.txt
-   importexport.txt
-   converters.txt
Index: main/waeup.kofa/trunk/src/waeup/kofa/utils/batching.txt
===================================================================
--- main/waeup.kofa/trunk/src/waeup/kofa/utils/batching.txt	(revision 12919)
+++ main/waeup.kofa/trunk/src/waeup/kofa/utils/batching.txt	(revision 12920)
@@ -1,4 +1,4 @@
-:mod:`waeup.kofa.utils.batching` -- Batch processing
-****************************************************
+Batch Processing
+****************
 
 Batch processing is much more than pure data import.
@@ -75,5 +75,5 @@
 
 
-Creating a batch processor
+Creating a Batch Processor
 ==========================
 
@@ -361,7 +361,5 @@
 
 
-
-
-Updating entries
+Updating Entries
 ----------------
 
@@ -523,5 +521,5 @@
     >>> shutil.rmtree(os.path.dirname(result[2]))
 
-Removing entries
+Removing Entries
 ----------------
 