Index: /main/waeup.kofa/trunk/docs/source/userdocs/testing.rst
===================================================================
--- /main/waeup.kofa/trunk/docs/source/userdocs/testing.rst	(revision 12926)
+++ /main/waeup.kofa/trunk/docs/source/userdocs/testing.rst	(revision 12927)
@@ -143,4 +143,8 @@
 
 
-Pythontests
-===========
+Python Tests
+============
+
+.. literalinclude:: ../../../src/waeup/kofa/browser/tests/test_browser.py
+   :pyobject: SupplementaryBrowserTests.test_suspended_officer
+
Index: /main/waeup.kofa/trunk/src/waeup/kofa/browser/tests/test_browser.py
===================================================================
--- /main/waeup.kofa/trunk/src/waeup/kofa/browser/tests/test_browser.py	(revision 12926)
+++ /main/waeup.kofa/trunk/src/waeup/kofa/browser/tests/test_browser.py	(revision 12927)
@@ -39,5 +39,6 @@
 
 class UniversitySetup(FunctionalTestCase):
-    # A test case that only contains a setup and teardown
+    """A test case that only contains a setup and teardown.
+    """
 
     layer = FunctionalLayer
@@ -104,5 +105,6 @@
 
 class DataCenterUITests(UniversitySetup):
-    # Tests for DataCenter class views and pages
+    """Tests for DataCenter class views and pages.
+    """
 
     layer = FunctionalLayer
@@ -167,5 +169,6 @@
 
 class DataCenterUIExportTests(UniversitySetup, FunctionalAsyncTestCase):
-    # Tests for DataCenter class views and pages
+    """Tests for DataCenter class views and pages.
+    """
 
     layer = FunctionalLayer
@@ -407,5 +410,6 @@
 
 class SupplementaryBrowserTests(UniversitySetup):
-    # These are additional tests to browser.txt
+    """These are additional tests to browser.txt
+    """
 
     def test_set_former_course(self):
@@ -448,6 +452,6 @@
     def test_suspended_officer(self):
         self.app['users'].addUser(
-            'officer', 'secret', title='Bob Officer', email='aa@aa.ng')
-        # Officer can't login if their password is not set
+            'officer', 'secret', title='Bob Officer', email='bob@abcd.ng')
+        # Officer can't login if their password is not set.
         self.app['users']['officer'].password = None
         self.browser.open('http://localhost/app/login')
@@ -457,8 +461,8 @@
         self.assertTrue(
             'You entered invalid credentials.' in self.browser.contents)
-        # We set the password again
+        # We set the password again.
         IUserAccount(
             self.app['users']['officer']).setPassword('secret')
-        # Officers can't login if their account is suspended/deactivated
+        # Officers can't login if their account is suspended/deactivated.
         self.app['users']['officer'].suspended = True
         self.browser.open('http://localhost/app/login')
@@ -469,4 +473,5 @@
             '...but yor account has been temporarily deactivated...',
             self.browser.contents)
+        # Officer is really not logged in.
         self.assertFalse("Bob Officer" in self.browser.contents)
         self.app['users']['officer'].suspended = False
@@ -475,10 +480,12 @@
         self.browser.getControl(name="form.password").value = 'secret'
         self.browser.getControl("Login").click()
+        # Yeah, office logged in.
         self.assertMatches(
             '...You logged in...', self.browser.contents)
         self.assertTrue("Bob Officer" in self.browser.contents)
         self.browser.getLink("Logout").click()
-        # Suspended accounts are marked
-        self.browser.addHeader('Authorization', 'Basic mgr:mgrpw')
+        # Login as manager.
+        self.browser.addHeader('Authorization', 'Basic mgr:mgrpw')
+        # Suspended accounts are marked in red.
         self.browser.open('http://localhost/app/users')
         self.assertFalse('(suspended)' in self.browser.contents)
@@ -488,4 +495,5 @@
             '<span style="color:red">(suspended)</span>'
             in self.browser.contents)
+        # A flash message appears on the edit page of the officer.
         self.browser.open('http://localhost/app/users/officer')
         self.assertTrue(