Index: /main/waeup.kofa/trunk/CHANGES.txt
===================================================================
--- /main/waeup.kofa/trunk/CHANGES.txt	(revision 12949)
+++ /main/waeup.kofa/trunk/CHANGES.txt	(revision 12950)
@@ -4,4 +4,6 @@
 1.3.2.dev0 (unreleased)
 =======================
+
+* Reorganize doctests. Remove deprecated doctests.
 
 * Enable temporary suspension of officer accounts. Plugins must be
Index: /main/waeup.kofa/trunk/docs/source/userdocs/testing/catalog.rst
===================================================================
--- /main/waeup.kofa/trunk/docs/source/userdocs/testing/catalog.rst	(revision 12949)
+++ /main/waeup.kofa/trunk/docs/source/userdocs/testing/catalog.rst	(revision 12950)
@@ -1,3 +1,3 @@
 .. _catalog_txt:
 
-.. include:: ../../../../src/waeup/kofa/catalog.txt
+.. include:: ../../../../src/waeup/kofa/doctests/catalog.txt
Index: /main/waeup.kofa/trunk/docs/source/userdocs/testing/certificate.rst
===================================================================
--- /main/waeup.kofa/trunk/docs/source/userdocs/testing/certificate.rst	(revision 12949)
+++ /main/waeup.kofa/trunk/docs/source/userdocs/testing/certificate.rst	(revision 12950)
@@ -1,5 +1,5 @@
 .. _certificate_txt:
 
-.. include:: ../../../../src/waeup/kofa/university/certificate.txt
+.. include:: ../../../../src/waeup/kofa/doctests/certificate.txt
 
-.. include:: ../../../../src/waeup/kofa/university/certcourses.txt
+.. include:: ../../../../src/waeup/kofa/doctests/certcourses.txt
Index: /main/waeup.kofa/trunk/docs/source/userdocs/testing/datacenter.rst
===================================================================
--- /main/waeup.kofa/trunk/docs/source/userdocs/testing/datacenter.rst	(revision 12949)
+++ /main/waeup.kofa/trunk/docs/source/userdocs/testing/datacenter.rst	(revision 12950)
@@ -1,3 +1,3 @@
 .. _datacenter_txt:
 
-.. include:: ../../../../src/waeup/kofa/datacenter.txt
+.. include:: ../../../../src/waeup/kofa/doctests/datacenter.txt
Index: /main/waeup.kofa/trunk/docs/source/userdocs/testing/permissions.rst
===================================================================
--- /main/waeup.kofa/trunk/docs/source/userdocs/testing/permissions.rst	(revision 12949)
+++ /main/waeup.kofa/trunk/docs/source/userdocs/testing/permissions.rst	(revision 12950)
@@ -1,3 +1,3 @@
 .. _permissions_txt:
 
-.. include:: ../../../../src/waeup/kofa/permissions.txt
+.. include:: ../../../../src/waeup/kofa/doctests/permissions.txt
Index: /main/waeup.kofa/trunk/docs/source/userdocs/testing/userscontainer.rst
===================================================================
--- /main/waeup.kofa/trunk/docs/source/userdocs/testing/userscontainer.rst	(revision 12949)
+++ /main/waeup.kofa/trunk/docs/source/userdocs/testing/userscontainer.rst	(revision 12950)
@@ -1,3 +1,3 @@
 .. _userscontainer_txt:
 
-.. include:: ../../../../src/waeup/kofa/userscontainer.txt
+.. include:: ../../../../src/waeup/kofa/doctests/userscontainer.txt
Index: /main/waeup.kofa/trunk/src/waeup/kofa/tests/test_doctests.py
===================================================================
--- /main/waeup.kofa/trunk/src/waeup/kofa/tests/test_doctests.py	(revision 12949)
+++ /main/waeup.kofa/trunk/src/waeup/kofa/tests/test_doctests.py	(revision 12950)
@@ -22,5 +22,5 @@
 def test_suite():
     suite = get_doctest_suite([
-            'authentication.txt',
+            'doctests/authentication.txt',
             ])
     return suite
Index: /main/waeup.kofa/trunk/src/waeup/kofa/university/tests/test_university.py
===================================================================
--- /main/waeup.kofa/trunk/src/waeup/kofa/university/tests/test_university.py	(revision 12949)
+++ /main/waeup.kofa/trunk/src/waeup/kofa/university/tests/test_university.py	(revision 12950)
@@ -33,5 +33,5 @@
 def test_suite():
     # collect doctests for university subpackage
-    suite = get_doctest_suite(['university/certcourses.txt',])
+    suite = get_doctest_suite(['doctests/certcourses.txt',])
     # add local unittests (actually only one)
     for testcase in [UniversitySubpackageTests,]: