Index: main/waeup.kofa/trunk/src/waeup/kofa/catalog.py
===================================================================
--- main/waeup.kofa/trunk/src/waeup/kofa/catalog.py	(revision 12950)
+++ main/waeup.kofa/trunk/src/waeup/kofa/catalog.py	(revision 12951)
@@ -32,8 +32,27 @@
 @implementer(IQuery)
 class KofaQuery(Query):
-    """A hurry.query-like query that supports also ``apply``.
+    """A `hurry.query.query.Query` compatible query that also supports
+    retrival of plain ``Bree`` result sets as used inside a catalog.
+
+    Like `hurry.query.query.Query` objects, `KofaQuery` is some kind
+    of a meta query or 'compound query' that can give the cataloged
+    objects (or their int ids) matching one or more 'subqueries'.
+
+    This way you can search for objects (or their int ids) that match
+    several criteria at the same time. See ``examples`` section below.
+
+    A singleton instance of this class is also available as global
+    utility.
+
+    A hurry.query-like query that supports also ``apply``.
     """
     def apply(self, query):
-        """Get a catalog's BTree set of intids conforming to a query.
+        """Get the list of int ids (a `BTree` result set) for objects
+        determined by ``query``.
+
+        The list of int ids is less expensive to compute than the
+        complete search results and sufficient, for instance, when you
+        only need the number of objects that match a query and not the
+        objects themselves.
         """
         return query.apply()
Index: main/waeup.kofa/trunk/src/waeup/kofa/doctests/app.txt
===================================================================
--- main/waeup.kofa/trunk/src/waeup/kofa/doctests/app.txt	(revision 12950)
+++ main/waeup.kofa/trunk/src/waeup/kofa/doctests/app.txt	(revision 12951)
@@ -1,4 +1,4 @@
-:mod:`waeup.kofa.app` -- central components for Kofa
-****************************************************
+Central Components
+******************
 
 .. :doctest:
@@ -6,20 +6,4 @@
 
 .. module:: waeup.kofa.app
-
-.. class:: University
-
-  The main Kofa application object is given with
-  :class:`University`. It provides the main containers as faculties,
-  hostels, etc.
-
-  .. attribute:: name
-
-     A string. The name of a university.
-
-  .. attribute:: faculties
-
-     An arbitrary object containing "faculties". In the case of
-     `University` it is a container of type
-     `waeup.kofa.interfaces.IFacultiesContainer`.
 
 
@@ -37,27 +21,27 @@
 instance:
 
-    >>> from waeup.kofa.app import University
-    >>> myuniversity = University()
-    >>> myuniversity
-    <waeup.kofa.app.University object at 0x...>
+  >>> from waeup.kofa.app import University
+  >>> myuniversity = University()
+  >>> myuniversity
+  <waeup.kofa.app.University object at 0x...>
 
 Instances of `University` comply with the interface
 `waeup.kofa.interfaces.IUniversity`:
 
-    >>> from zope.interface.verify import verifyClass
-    >>> from waeup.kofa.interfaces import IUniversity
-    >>> verifyClass(IUniversity, University)
-    True
+  >>> from zope.interface.verify import verifyClass
+  >>> from waeup.kofa.interfaces import IUniversity
+  >>> verifyClass(IUniversity, University)
+  True
 
 A freshly created instance provides the attributes promised by the
 interface:
 
-    >>> from waeup.kofa.app import University
-    >>> myuniversity = University()
-    >>> myuniversity['configuration'].name
-    u'Sample University'
+  >>> from waeup.kofa.app import University
+  >>> myuniversity = University()
+  >>> myuniversity['configuration'].name
+  u'Sample University'
 
-    >>> myuniversity['faculties']
-    <waeup.kofa.university.facultiescontainer.FacultiesContainer object at 0x...>
+  >>> myuniversity['faculties']
+  <waeup.kofa.university.facultiescontainer.FacultiesContainer object at 0x...>
 
   >>> myuniversity['students']
Index: main/waeup.kofa/trunk/src/waeup/kofa/doctests/authentication.txt
===================================================================
--- main/waeup.kofa/trunk/src/waeup/kofa/doctests/authentication.txt	(revision 12950)
+++ main/waeup.kofa/trunk/src/waeup/kofa/doctests/authentication.txt	(revision 12951)
@@ -1,4 +1,4 @@
-Kofa authentication
-*******************
+Authentication
+**************
 
 We need to protect most pieces of our portals from unauthenticated
@@ -24,6 +24,6 @@
   >>> browser.handleErrors = False
 
-Creating users (principals)
-===========================
+Creating officers
+=================
 
 Before we can login, we have to provide a user (``principal`` in Zope
@@ -42,6 +42,6 @@
 See ``userscontainer.txt`` for details about the UsersContainer we use here.
 
-Users and local roles
-=====================
+Officers and local roles
+========================
 
 Accounts also hold infos about local roles assigned to a user. In the
Index: main/waeup.kofa/trunk/src/waeup/kofa/doctests/catalog.txt
===================================================================
--- main/waeup.kofa/trunk/src/waeup/kofa/doctests/catalog.txt	(revision 12950)
+++ main/waeup.kofa/trunk/src/waeup/kofa/doctests/catalog.txt	(revision 12951)
@@ -10,43 +10,6 @@
 .. :layer: waeup.kofa.testing.KofaUnitTestLayer
 
-The KofaQuery Class
-===================
-
-.. class:: KofaQuery()
-
-   .. attribute:: grok.implements(hurry.query.interfaces.IQuery)
-
-   A `hurry.query.query.Query` compatible query that also supports
-   retrival of plain ``Bree`` result sets as used inside a catalog.
-
-   Like `hurry.query.query.Query` objects, `KofaQuery` is some kind
-   of a meta query or 'compound query' that can give the cataloged
-   objects (or their int ids) matching one or more 'subqueries'.
-
-   This way you can search for objects (or their int ids) that match
-   several criteria at the same time. See ``examples`` section below.
-
-   A singleton instance of this class is also available as global
-   utility.
-
-   .. method:: searchResults(query)
-
-     Get the cataloged objects determined by ``query``.
-
-   .. method:: apply(query)
-
-     Get the list of int ids (a `BTree` result set) for objects
-     determined by ``query``.
-
-     The list of int ids is less expensive to compute than the
-     complete search results and sufficient, for instance, when you
-     only need the number of objects that match a query and not the
-     objects themselves.
-
-Examples
-========
-
 Getting a general query object
-------------------------------
+==============================
 
 We can get a KofaQuery object by asking for an unnamed global utility
@@ -64,5 +27,5 @@
 
 Setting up a catalog and feeding it
------------------------------------
+===================================
 
     >>> from zope.catalog.interfaces import ICatalog
@@ -143,5 +106,5 @@
 
 Searching for result sets
--------------------------
+=========================
 
 Finally we can perform queries:
@@ -193,5 +156,5 @@
 
 Searching for objects
----------------------
+=====================
 
 Very often we don't want to know the catalog-internal 'ids' of
Index: main/waeup.kofa/trunk/src/waeup/kofa/doctests/certcourse.txt
===================================================================
--- main/waeup.kofa/trunk/src/waeup/kofa/doctests/certcourse.txt	(revision 12951)
+++ main/waeup.kofa/trunk/src/waeup/kofa/doctests/certcourse.txt	(revision 12951)
@@ -0,0 +1,221 @@
+.. _removecertificatecourses:
+
+Persistence of Certificate Courses
+==================================
+
+If a certificate course requires a certain course and this is course
+is deleted, also the referring certificate course is deleted.
+
+We setup a data structure that reflects typical usage. It looks like
+this::
+
+    Department-Instance
+    |
+    +---> courses
+    |        |
+    |        +--------------------> Course-Instance
+    |                                        ^
+    +---> certificates                       |
+             |                               |
+             +-----> Certificate-Instance    |
+                        |                    |
+                        +------> Certificate-Course
+
+The Certifcate Course here refers to a Course instance.
+
+In Python we build such a structure like this (from top to bottom):
+
+    >>> from zope.component import createObject
+    >>> mydept = createObject('waeup.Department')
+
+In real world use this data will be stored in a ZODB. We setup our own
+litte ZODB backend (which is easy!):
+
+    >>> from ZODB import FileStorage, DB
+    >>> dbpath = 'tinyData.fs'
+    >>> class TinyZODB(object):
+    ...   def __init__(self, path=dbpath):
+    ...     self.storage = FileStorage.FileStorage(path)
+    ...     self.db = DB(self.storage)
+    ...     self.connection = self.db.open()
+    ...     self.dbroot = self.connection.root()
+    ...   def close(self):
+    ...     self.connection.close()
+    ...     self.db.close()
+    ...     self.storage.close()
+
+Now we can use this ZODB as backend database and store our data
+structure:
+
+    >>> import transaction
+    >>> db = TinyZODB()
+    >>> dbroot = db.dbroot
+    >>> dbroot['mydept'] = mydept
+    >>> mycourse = createObject('waeup.Course')
+    >>> mycourse.code = 'MYCOURSE'
+    >>> mydept.courses.addCourse(mycourse)
+    >>> mycert = createObject('waeup.Certificate')
+    >>> mycert.code = 'MYCERT'
+    >>> mydept.certificates.addCertificate(mycert)
+    >>> mycert.addCertCourse(mycourse)
+
+    >>> transaction.commit()
+
+The data is now stored in the ZODB. We can close the DB, reopen it
+later and the data will still be there:
+
+    >>> db.close()
+    >>> newdb = TinyZODB()
+    >>> newdbroot = newdb.dbroot
+    >>> list(newdbroot)
+    ['mydept']
+
+The certificate course we stored in the certificate is indeed a
+referrer of the course, not a copy of it:
+
+    >>> course = newdbroot['mydept'].courses['MYCOURSE']
+    >>> certcourse = newdbroot['mydept'].certificates['MYCERT']['MYCOURSE_100']
+    >>> certcourse.course is course
+    True
+
+So, we can be sure that modifications to the course are immediately
+reflected in the certcourse.
+
+We can also be sure, that when removing courses or referrers of them,
+other data will be handled in a way we expect. That is,
+
+* when we remove a course, we want all referrers to it be removed as
+  well
+
+* when we remove a referrer of a course, nothing else should be
+  touched but only this very referrer.
+
+
+As correct deletion of referrer needs support of catalogs (we lookup
+catalogs to find referrers), we need a fully blown ZODB here,
+including an instance of :class:`waeup.kofa.app.University`, as this is our
+`ISite` object where the catalogs are stored.
+
+We create a complete university tree, starting with a
+:class:`University` instance and going down to courses, certificats
+and course certificates:
+
+    >>> from waeup.kofa.app import University
+    >>> root = getRootFolder()
+    >>> root['app'] = University()
+
+We have to set the site, to enable proper working of catalogs and
+`IObjectRemoved` handlers:
+
+    >>> from zope.app.component.hooks import setSite
+    >>> setSite(root['app'])
+
+    >>> from zope.component import createObject
+    >>> faculty = createObject('waeup.Faculty')
+    >>> faculty.code = 'FAC'
+    >>> root['app']['faculties'].addFaculty(faculty)
+    >>> fac = root['app']['faculties']['FAC']
+
+    >>> dept = createObject('waeup.Department')
+    >>> dept.code = 'DEPT'
+    >>> root['app']['faculties']['FAC'].addDepartment(dept)
+
+    >>> course = createObject('waeup.Course')
+    >>> course.code = 'CRS1'
+    >>> fac['DEPT'].courses.addCourse(course)
+
+Now let's add another department, which will also hold a course:
+
+    >>> dept2 = createObject('waeup.Department')
+    >>> dept2.code = 'DEPT2'
+    >>> root['app']['faculties']['FAC'].addDepartment(dept2)
+
+    >>> course = createObject('waeup.Course')
+    >>> course.code = 'CRS2'
+    >>> fac['DEPT2'].courses.addCourse(course)
+
+Finally, we add a certificate with referrers (certificate courses) to
+the created courses:
+
+    >>> cert = createObject('waeup.Certificate')
+    >>> cert.code = 'CERT'
+    >>> fac['DEPT'].certificates.addCertificate(cert)
+
+    >>> fac['DEPT'].certificates['CERT'].addCertCourse(
+    ...   fac['DEPT'].courses['CRS1'])
+
+    >>> fac['DEPT'].certificates['CERT'].addCertCourse(
+    ...   fac['DEPT2'].courses['CRS2'])
+
+We add the latter course again, but this time for the second level:
+
+    >>> fac['DEPT'].certificates['CERT'].addCertCourse(
+    ...   fac['DEPT2'].courses['CRS2'], level=200)
+
+So, we have three referrers in our certificate of two different
+courses stored somewhere in the application:
+
+    >>> list(fac['DEPT'].certificates['CERT'])
+    [u'CRS1_100', u'CRS2_100', u'CRS2_200']
+
+Both, the courses themselves and the referrers of them, are the same
+(not only equal):
+
+    >>> a = root['app']['faculties']['FAC']['DEPT']
+    >>> b1 = a.courses['CRS1']
+    >>> b2 = a.certificates['CERT']['CRS1_100'].course
+    >>> b1 is b2
+    True
+
+If we remove the course, also the select item in the certificate course
+will be gone:
+
+    >>> list(a.certificates['CERT'])
+    [u'CRS1_100', u'CRS2_100', u'CRS2_200']
+
+    >>> list(a.courses)
+    [u'CRS1']
+
+    >>> del root['app']['faculties']['FAC']['DEPT'].courses['CRS1']
+    >>> list(a.certificates['CERT'])
+    [u'CRS2_100', u'CRS2_200']
+
+    >>> list(a.courses)
+    []
+
+If we remove a referrer of a course, this will not touch the course
+nor other referrers:
+
+    >>> del fac['DEPT'].certificates['CERT']['CRS2_200']
+    >>> list(a.certificates['CERT'])
+    [u'CRS2_100']
+
+    >>> list(fac['DEPT2'].courses)
+    [u'CRS2']
+
+If a single course is registered for several levels in a single
+certificate, this will not block things if the course is removed
+(regression test):
+
+We add the same course as a reference for level 200 and level 300:
+
+    >>> fac['DEPT'].certificates['CERT'].addCertCourse(
+    ...   fac['DEPT2'].courses['CRS2'], level=200)
+    >>> fac['DEPT'].certificates['CERT'].addCertCourse(
+    ...   fac['DEPT2'].courses['CRS2'], level=300)
+
+Deleting the course (thus also the refererrers) will work:
+
+    >>> del root['app']['faculties']['FAC']['DEPT2'].courses['CRS2']
+
+Now all references are gone:
+
+    >>> list(a.certificates['CERT'])
+    []
+
+and also the course itself vanished:
+
+    >>> list(fac['DEPT2'].courses)
+    []
+
+
Index: main/waeup.kofa/trunk/src/waeup/kofa/doctests/certcourses.txt
===================================================================
--- main/waeup.kofa/trunk/src/waeup/kofa/doctests/certcourses.txt	(revision 12950)
+++ 	(revision )
@@ -1,221 +1,0 @@
-.. _removecertificatecourses:
-
-Persistence of Certificate Courses
-==================================
-
-If a certificate course requires a certain course and this is course
-is deleted, also the referring certificate course is deleted.
-
-We setup a data structure that reflects typical usage. It looks like
-this::
-
-    Department-Instance
-    |
-    +---> courses
-    |        |
-    |        +--------------------> Course-Instance
-    |                                        ^
-    +---> certificates                       |
-             |                               |
-             +-----> Certificate-Instance    |
-                        |                    |
-                        +------> Certificate-Course
-
-The Certifcate Course here refers to a Course instance.
-
-In Python we build such a structure like this (from top to bottom):
-
-    >>> from zope.component import createObject
-    >>> mydept = createObject('waeup.Department')
-
-In real world use this data will be stored in a ZODB. We setup our own
-litte ZODB backend (which is easy!):
-
-    >>> from ZODB import FileStorage, DB
-    >>> dbpath = 'tinyData.fs'
-    >>> class TinyZODB(object):
-    ...   def __init__(self, path=dbpath):
-    ...     self.storage = FileStorage.FileStorage(path)
-    ...     self.db = DB(self.storage)
-    ...     self.connection = self.db.open()
-    ...     self.dbroot = self.connection.root()
-    ...   def close(self):
-    ...     self.connection.close()
-    ...     self.db.close()
-    ...     self.storage.close()
-
-Now we can use this ZODB as backend database and store our data
-structure:
-
-    >>> import transaction
-    >>> db = TinyZODB()
-    >>> dbroot = db.dbroot
-    >>> dbroot['mydept'] = mydept
-    >>> mycourse = createObject('waeup.Course')
-    >>> mycourse.code = 'MYCOURSE'
-    >>> mydept.courses.addCourse(mycourse)
-    >>> mycert = createObject('waeup.Certificate')
-    >>> mycert.code = 'MYCERT'
-    >>> mydept.certificates.addCertificate(mycert)
-    >>> mycert.addCertCourse(mycourse)
-
-    >>> transaction.commit()
-
-The data is now stored in the ZODB. We can close the DB, reopen it
-later and the data will still be there:
-
-    >>> db.close()
-    >>> newdb = TinyZODB()
-    >>> newdbroot = newdb.dbroot
-    >>> list(newdbroot)
-    ['mydept']
-
-The certificate course we stored in the certificate is indeed a
-referrer of the course, not a copy of it:
-
-    >>> course = newdbroot['mydept'].courses['MYCOURSE']
-    >>> certcourse = newdbroot['mydept'].certificates['MYCERT']['MYCOURSE_100']
-    >>> certcourse.course is course
-    True
-
-So, we can be sure that modifications to the course are immediately
-reflected in the certcourse.
-
-We can also be sure, that when removing courses or referrers of them,
-other data will be handled in a way we expect. That is,
-
-* when we remove a course, we want all referrers to it be removed as
-  well
-
-* when we remove a referrer of a course, nothing else should be
-  touched but only this very referrer.
-
-
-As correct deletion of referrer needs support of catalogs (we lookup
-catalogs to find referrers), we need a fully blown ZODB here,
-including an instance of :class:`waeup.kofa.app.University`, as this is our
-`ISite` object where the catalogs are stored.
-
-We create a complete university tree, starting with a
-:class:`University` instance and going down to courses, certificats
-and course certificates:
-
-    >>> from waeup.kofa.app import University
-    >>> root = getRootFolder()
-    >>> root['app'] = University()
-
-We have to set the site, to enable proper working of catalogs and
-`IObjectRemoved` handlers:
-
-    >>> from zope.app.component.hooks import setSite
-    >>> setSite(root['app'])
-
-    >>> from zope.component import createObject
-    >>> faculty = createObject('waeup.Faculty')
-    >>> faculty.code = 'FAC'
-    >>> root['app']['faculties'].addFaculty(faculty)
-    >>> fac = root['app']['faculties']['FAC']
-
-    >>> dept = createObject('waeup.Department')
-    >>> dept.code = 'DEPT'
-    >>> root['app']['faculties']['FAC'].addDepartment(dept)
-
-    >>> course = createObject('waeup.Course')
-    >>> course.code = 'CRS1'
-    >>> fac['DEPT'].courses.addCourse(course)
-
-Now let's add another department, which will also hold a course:
-
-    >>> dept2 = createObject('waeup.Department')
-    >>> dept2.code = 'DEPT2'
-    >>> root['app']['faculties']['FAC'].addDepartment(dept2)
-
-    >>> course = createObject('waeup.Course')
-    >>> course.code = 'CRS2'
-    >>> fac['DEPT2'].courses.addCourse(course)
-
-Finally, we add a certificate with referrers (certificate courses) to
-the created courses:
-
-    >>> cert = createObject('waeup.Certificate')
-    >>> cert.code = 'CERT'
-    >>> fac['DEPT'].certificates.addCertificate(cert)
-
-    >>> fac['DEPT'].certificates['CERT'].addCertCourse(
-    ...   fac['DEPT'].courses['CRS1'])
-
-    >>> fac['DEPT'].certificates['CERT'].addCertCourse(
-    ...   fac['DEPT2'].courses['CRS2'])
-
-We add the latter course again, but this time for the second level:
-
-    >>> fac['DEPT'].certificates['CERT'].addCertCourse(
-    ...   fac['DEPT2'].courses['CRS2'], level=200)
-
-So, we have three referrers in our certificate of two different
-courses stored somewhere in the application:
-
-    >>> list(fac['DEPT'].certificates['CERT'])
-    [u'CRS1_100', u'CRS2_100', u'CRS2_200']
-
-Both, the courses themselves and the referrers of them, are the same
-(not only equal):
-
-    >>> a = root['app']['faculties']['FAC']['DEPT']
-    >>> b1 = a.courses['CRS1']
-    >>> b2 = a.certificates['CERT']['CRS1_100'].course
-    >>> b1 is b2
-    True
-
-If we remove the course, also the select item in the certificate course
-will be gone:
-
-    >>> list(a.certificates['CERT'])
-    [u'CRS1_100', u'CRS2_100', u'CRS2_200']
-
-    >>> list(a.courses)
-    [u'CRS1']
-
-    >>> del root['app']['faculties']['FAC']['DEPT'].courses['CRS1']
-    >>> list(a.certificates['CERT'])
-    [u'CRS2_100', u'CRS2_200']
-
-    >>> list(a.courses)
-    []
-
-If we remove a referrer of a course, this will not touch the course
-nor other referrers:
-
-    >>> del fac['DEPT'].certificates['CERT']['CRS2_200']
-    >>> list(a.certificates['CERT'])
-    [u'CRS2_100']
-
-    >>> list(fac['DEPT2'].courses)
-    [u'CRS2']
-
-If a single course is registered for several levels in a single
-certificate, this will not block things if the course is removed
-(regression test):
-
-We add the same course as a reference for level 200 and level 300:
-
-    >>> fac['DEPT'].certificates['CERT'].addCertCourse(
-    ...   fac['DEPT2'].courses['CRS2'], level=200)
-    >>> fac['DEPT'].certificates['CERT'].addCertCourse(
-    ...   fac['DEPT2'].courses['CRS2'], level=300)
-
-Deleting the course (thus also the refererrers) will work:
-
-    >>> del root['app']['faculties']['FAC']['DEPT2'].courses['CRS2']
-
-Now all references are gone:
-
-    >>> list(a.certificates['CERT'])
-    []
-
-and also the course itself vanished:
-
-    >>> list(fac['DEPT2'].courses)
-    []
-
-
Index: main/waeup.kofa/trunk/src/waeup/kofa/doctests/certificatescontainer.txt
===================================================================
--- main/waeup.kofa/trunk/src/waeup/kofa/doctests/certificatescontainer.txt	(revision 12950)
+++ main/waeup.kofa/trunk/src/waeup/kofa/doctests/certificatescontainer.txt	(revision 12951)
@@ -1,4 +1,4 @@
-:mod:`waeup.kofa.university.certificatescontainer` -- Certificate containers
-****************************************************************************
+Certificate Containers
+**********************
 
 .. module:: waeup.kofa.university.certificatescontainer
Index: main/waeup.kofa/trunk/src/waeup/kofa/doctests/course.txt
===================================================================
--- main/waeup.kofa/trunk/src/waeup/kofa/doctests/course.txt	(revision 12950)
+++ main/waeup.kofa/trunk/src/waeup/kofa/doctests/course.txt	(revision 12951)
@@ -1,4 +1,4 @@
-:mod:`waeup.kofa.university.course` -- Courses
-**********************************************
+Courses
+*******
 
 .. module:: waeup.kofa.university.course
Index: main/waeup.kofa/trunk/src/waeup/kofa/doctests/coursescontainer.txt
===================================================================
--- main/waeup.kofa/trunk/src/waeup/kofa/doctests/coursescontainer.txt	(revision 12950)
+++ main/waeup.kofa/trunk/src/waeup/kofa/doctests/coursescontainer.txt	(revision 12951)
@@ -1,4 +1,4 @@
-:mod:`waeup.kofa.university.coursescontainer` -- Course containers
-******************************************************************
+Course Containers
+*****************
 
 .. module:: waeup.kofa.university.coursescontainer
Index: main/waeup.kofa/trunk/src/waeup/kofa/doctests/department.txt
===================================================================
--- main/waeup.kofa/trunk/src/waeup/kofa/doctests/department.txt	(revision 12950)
+++ main/waeup.kofa/trunk/src/waeup/kofa/doctests/department.txt	(revision 12951)
@@ -1,4 +1,4 @@
-:mod:`waeup.kofa.university.department` -- Departments
-******************************************************
+Departments
+***********
 
 .. module:: waeup.kofa.university.department
Index: main/waeup.kofa/trunk/src/waeup/kofa/doctests/facultiescontainer.txt
===================================================================
--- main/waeup.kofa/trunk/src/waeup/kofa/doctests/facultiescontainer.txt	(revision 12950)
+++ main/waeup.kofa/trunk/src/waeup/kofa/doctests/facultiescontainer.txt	(revision 12951)
@@ -1,4 +1,4 @@
-:mod:`waeup.kofa.university.facultiescontainer` -- Faculty Containers
-*********************************************************************
+Faculty Containers
+******************
 
 .. module:: waeup.kofa.university.facultiescontainer
Index: main/waeup.kofa/trunk/src/waeup/kofa/doctests/faculty.txt
===================================================================
--- main/waeup.kofa/trunk/src/waeup/kofa/doctests/faculty.txt	(revision 12950)
+++ main/waeup.kofa/trunk/src/waeup/kofa/doctests/faculty.txt	(revision 12951)
@@ -1,4 +1,4 @@
-:mod:`waeup.kofa.university.faculty` -- Faculties
-*************************************************
+Faculties
+*********
 
 .. module:: waeup.kofa.university.faculty
Index: main/waeup.kofa/trunk/src/waeup/kofa/doctests/helpers.txt
===================================================================
--- main/waeup.kofa/trunk/src/waeup/kofa/doctests/helpers.txt	(revision 12950)
+++ main/waeup.kofa/trunk/src/waeup/kofa/doctests/helpers.txt	(revision 12951)
@@ -1,4 +1,4 @@
-:mod:`waeup.kofa.utils.helpers` -- Helpers for Kofa
-***************************************************
+Helpers for Kofa
+****************
 
 .. module:: waeup.kofa.utils.helpers
Index: main/waeup.kofa/trunk/src/waeup/kofa/university/tests/test_university.py
===================================================================
--- main/waeup.kofa/trunk/src/waeup/kofa/university/tests/test_university.py	(revision 12950)
+++ main/waeup.kofa/trunk/src/waeup/kofa/university/tests/test_university.py	(revision 12951)
@@ -33,5 +33,5 @@
 def test_suite():
     # collect doctests for university subpackage
-    suite = get_doctest_suite(['doctests/certcourses.txt',])
+    suite = get_doctest_suite(['doctests/certcourse.txt',])
     # add local unittests (actually only one)
     for testcase in [UniversitySubpackageTests,]: