Index: main/waeup.kofa/trunk/docs/source/userdocs/academics.rst
===================================================================
--- main/waeup.kofa/trunk/docs/source/userdocs/academics.rst	(revision 12952)
+++ main/waeup.kofa/trunk/docs/source/userdocs/academics.rst	(revision 12953)
@@ -58,4 +58,5 @@
 
   .. autoattribute:: waeup.kofa.university.faculty.Faculty.local_roles
+     :noindex:
 
 
@@ -78,5 +79,5 @@
 
   .. autoattribute:: waeup.kofa.university.department.Department.local_roles
-
+     :noindex:
 
 Courses
Index: main/waeup.kofa/trunk/docs/source/userdocs/datacenter/export.rst
===================================================================
--- main/waeup.kofa/trunk/docs/source/userdocs/datacenter/export.rst	(revision 12952)
+++ main/waeup.kofa/trunk/docs/source/userdocs/datacenter/export.rst	(revision 12953)
@@ -41,5 +41,4 @@
 
 .. autoclass:: waeup.kofa.userscontainer.UserExporter()
-  :noindex:
 
   .. autoattribute:: waeup.kofa.userscontainer.UserExporter.fields
@@ -51,5 +50,4 @@
 
 .. autoclass:: waeup.kofa.university.export.FacultyExporter()
-  :noindex:
 
   .. autoattribute:: waeup.kofa.university.export.FacultyExporter.fields
@@ -61,5 +59,4 @@
 
 .. autoclass:: waeup.kofa.university.export.DepartmentExporter()
-  :noindex:
 
   .. autoattribute:: waeup.kofa.university.export.DepartmentExporter.fields
@@ -71,5 +68,4 @@
 
 .. autoclass:: waeup.kofa.university.export.CourseExporter()
-  :noindex:
 
   .. autoattribute:: waeup.kofa.university.export.CourseExporter.fields
@@ -81,5 +77,4 @@
 
 .. autoclass:: waeup.kofa.university.export.CertificateExporter()
-  :noindex:
 
   .. autoattribute:: waeup.kofa.university.export.CertificateExporter.fields
@@ -91,5 +86,4 @@
 
 .. autoclass:: waeup.kofa.university.export.CertificateCourseExporter()
-  :noindex:
 
   .. autoattribute:: waeup.kofa.university.export.CertificateCourseExporter.fields
@@ -101,5 +95,4 @@
 
 .. autoclass:: waeup.kofa.accesscodes.export.AccessCodeBatchExporter()
-  :noindex:
 
   .. autoattribute:: waeup.kofa.accesscodes.export.AccessCodeBatchExporter.fields
@@ -110,5 +103,4 @@
 
 .. autoclass:: waeup.kofa.accesscodes.export.AccessCodeExporter()
-  :noindex:
 
   .. autoattribute:: waeup.kofa.accesscodes.export.AccessCodeExporter.fields
@@ -120,5 +112,4 @@
 
 .. autoclass:: waeup.kofa.hostels.export.HostelExporter()
-  :noindex:
 
   .. autoattribute:: waeup.kofa.hostels.export.HostelExporter.fields
@@ -129,5 +120,4 @@
 
 .. autoclass:: waeup.kofa.hostels.export.BedExporter()
-  :noindex:
 
   .. autoattribute:: waeup.kofa.hostels.export.BedExporter.fields
@@ -141,5 +131,4 @@
 
 .. autoclass:: waeup.kofa.applicants.export.ApplicantsContainerExporter()
-  :noindex:
 
   .. autoattribute:: waeup.kofa.applicants.export.ApplicantsContainerExporter.fields
@@ -150,5 +139,4 @@
 
 .. autoclass:: waeup.kofa.applicants.export.ApplicantExporter()
-  :noindex:
 
   .. autoattribute:: waeup.kofa.applicants.export.ApplicantExporter.fields
@@ -184,5 +172,4 @@
 
 .. autoclass:: waeup.kofa.students.export.StudentExporter()
-  :noindex:
 
   .. autoattribute:: waeup.kofa.students.export.StudentExporter.fields
@@ -194,5 +181,4 @@
 
 .. autoclass:: waeup.kofa.students.export.StudentStudyCourseExporter()
-  :noindex:
 
   .. autoattribute:: waeup.kofa.students.export.StudentStudyCourseExporter.fields
@@ -204,5 +190,4 @@
 
 .. autoclass:: waeup.kofa.students.export.StudentStudyLevelExporter()
-  :noindex:
 
   .. autoattribute:: waeup.kofa.students.export.StudentStudyLevelExporter.fields
@@ -214,5 +199,4 @@
 
 .. autoclass:: waeup.kofa.students.export.CourseTicketExporter()
-  :noindex:
 
   .. autoattribute:: waeup.kofa.students.export.CourseTicketExporter.fields
@@ -224,5 +208,4 @@
 
 .. autoclass:: waeup.kofa.students.export.StudentPaymentExporter()
-  :noindex:
 
   .. autoattribute:: waeup.kofa.students.export.StudentPaymentExporter.fields
@@ -234,5 +217,4 @@
 
 .. autoclass:: waeup.kofa.students.export.BedTicketExporter()
-  :noindex:
 
   .. autoattribute:: waeup.kofa.students.export.BedTicketExporter.fields
@@ -254,5 +236,4 @@
 
 .. autoclass:: waeup.kofa.students.export.DataForBursaryExporter()
-  :noindex:
 
   .. autoattribute:: waeup.kofa.students.export.DataForBursaryExporter.fields
@@ -264,5 +245,4 @@
 
 .. autoclass:: waeup.kofa.students.export.StudentPaymentsOverviewExporter()
-  :noindex:
 
   .. autoattribute:: waeup.kofa.students.export.StudentPaymentsOverviewExporter.fields
@@ -275,5 +255,4 @@
 
 .. autoclass:: waeup.kofa.students.export.StudentStudyLevelsOverviewExporter()
-  :noindex:
 
   .. autoattribute:: waeup.kofa.students.export.StudentStudyLevelsOverviewExporter.fields
@@ -285,5 +264,4 @@
 
 .. autoclass:: waeup.kofa.students.export.ComboCardDataExporter()
-  :noindex:
 
   .. autoattribute:: waeup.kofa.students.export.ComboCardDataExporter.fields