Index: main/waeup.kofa/trunk/src/waeup/kofa/browser/pages.py
===================================================================
--- main/waeup.kofa/trunk/src/waeup/kofa/browser/pages.py	(revision 12954)
+++ main/waeup.kofa/trunk/src/waeup/kofa/browser/pages.py	(revision 12955)
@@ -73,5 +73,5 @@
 from waeup.kofa.students.catalog import StudentQueryResultItem
 from waeup.kofa.students.interfaces import IStudentsUtils
-from waeup.kofa.students.vocabularies import StudyLevelSource
+from waeup.kofa.students.vocabularies import StudyLevelSource, GenderSource
 
 FORBIDDEN_CHARACTERS = (160,)
@@ -511,10 +511,15 @@
         return
 
-    def _set_levels(self):
+    def _set_course_levels(self):
+        vocab_terms = course_levels.by_value.values()
+        self.course_levels = sorted([(x.token, x.title,) for x in vocab_terms])
+        return
+
+    def _set_study_levels(self):
         studylevelsource = StudyLevelSource().factory
-        self.levels = []
+        self.study_levels = []
         for code in studylevelsource.getValues(None):
             title = studylevelsource.getTitle(None, code)
-            self.levels.append((code, title))
+            self.study_levels.append((code, title))
         return
 
@@ -553,8 +558,17 @@
         return
 
+    def _set_sex(self):
+        gendersource = GenderSource().factory
+        self.sex = []
+        for sex in gendersource.getValues():
+            title = gendersource.getTitle(sex)
+            self.sex.append((sex, title))
+        return
+
     def update(self):
         self._set_inst_types()
         self._set_sessions()
-        self._set_levels()
+        self._set_course_levels()
+        self._set_study_levels()
         self._set_study_modes()
         self._set_student_states()
@@ -564,4 +578,5 @@
         self._set_app_cats()
         self._set_payment_cats()
+        self._set_sex()
 
 class AdministrationPage(KofaPage):
Index: main/waeup.kofa/trunk/src/waeup/kofa/browser/viewlets.py
===================================================================
--- main/waeup.kofa/trunk/src/waeup/kofa/browser/viewlets.py	(revision 12954)
+++ main/waeup.kofa/trunk/src/waeup/kofa/browser/viewlets.py	(revision 12955)
@@ -844,5 +844,5 @@
 
 class InstTypesSource(grok.Viewlet):
-    """Avalable institution types for the sources overview page.
+    """Available institution types for the sources overview page.
     """
     grok.order(1)
@@ -871,5 +871,5 @@
 
 class SessionSource(InstTypesSource):
-    """Avalable sessions for the sources overview page.
+    """Available sessions for the sources overview page.
     """
     grok.order(2)
@@ -878,16 +878,24 @@
     title = _('Academic Sessions')
 
+class CourseLevelSource(InstTypesSource):
+    """Available course levels for the sources overview page.
+    """
+    grok.order(3)
+    name = 'CourseLevels'
+    source_name = 'course_levels'
+    title = _('Course Levels')
+
 class StudyLevelSource(InstTypesSource):
-    """Avalable study levels for the sources overview page.
-    """
-    grok.order(3)
-    name = 'Levels'
-    source_name = 'levels'
+    """Available study levels for the sources overview page.
+    """
+    grok.order(4)
+    name = 'StudyLevels'
+    source_name = 'study_levels'
     title = _('Study Levels')
 
 class StudyModeSource(InstTypesSource):
-    """Avalable study modes for the sources overview page.
-    """
-    grok.order(4)
+    """Available study modes for the sources overview page.
+    """
+    grok.order(5)
     name = 'StudyModes'
     source_name = 'study_modes'
@@ -895,5 +903,5 @@
 
 class AppCatsSource(InstTypesSource):
-    """Avalable application categories for the sources overview page.
+    """Available application categories for the sources overview page.
     """
     grok.order(5)
@@ -902,6 +910,14 @@
     title = _('Application Categories')
 
+class PaymentCatsSource(InstTypesSource):
+    """Available payment categories for the sources overview page.
+    """
+    grok.order(6)
+    name = 'PaymentCats'
+    source_name = 'payment_cats'
+    title = _('Payment Categories')
+
 class StudentStatesSource(InstTypesSource):
-    """Avalable student sates for the sources overview page.
+    """Available student sates for the sources overview page.
     """
     grok.order(1)
@@ -913,5 +929,5 @@
 
 class VerdictsSource(InstTypesSource):
-    """Avalable verdicts for the sources overview page.
+    """Available verdicts for the sources overview page.
     """
     grok.order(2)
@@ -922,16 +938,6 @@
     title = _('Verdicts')
 
-class PaymentCatsSource(InstTypesSource):
-    """Avalable payment categories for the sources overview page.
-    """
-    grok.order(3)
-    grok.viewletmanager(SourcesRight)
-    column = 'right'
-    name = 'PaymentCats'
-    source_name = 'payment_cats'
-    title = _('Payment Categories')
-
 class ExamSubjectsSource(InstTypesSource):
-    """Avalable exam subjects for the sources overview page.
+    """Available exam subjects for the sources overview page.
     """
     grok.order(4)
@@ -943,5 +949,5 @@
 
 class ExamGradesSource(InstTypesSource):
-    """Avalable exam grades for the sources overview page.
+    """Available exam grades for the sources overview page.
     """
     grok.order(5)
@@ -952,2 +958,12 @@
     title = _('Exam Grades')
 
+class SexSource(InstTypesSource):
+    """Available sex values for the sources overview page.
+    """
+    grok.order(6)
+    grok.viewletmanager(SourcesRight)
+    column = 'right'
+    name = 'Sex'
+    source_name = 'sex'
+    title = _('Sex')
+